set termout on
set echo on
set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set trimspool on

spool vpdplan.log

select * from v$version;

drop user test cascade;

create user test identified by test;
grant dba to test;

create table test.table_list as select * from dba_tables;

CREATE OR REPLACE FUNCTION TEST.VPD_FUNCTION(d1 varchar2,d2 varchar2) return varchar2
is
predicate varchar2 (2000);
begin
  predicate := 'owner<>''SYS''';
  return predicate;
end;
/

begin

SYS.DBMS_RLS.ADD_POLICY     (
      object_schema          => 'TEST'
      ,object_name           => 'TABLE_LIST'
      ,policy_name           => 'VPD_TEST_POLICY'
      ,function_schema       => 'TEST'
      ,policy_function       => 'VPD_FUNCTION'
      ,statement_types       => 'SELECT'
      ,policy_type           => DBMS_RLS.DYNAMIC
      ,long_predicate        => FALSE
      ,update_check          => FALSE
      ,static_policy         => FALSE
      ,enable                => TRUE );

END;
/

select count(*) from test.table_list;
select * from table(dbms_xplan.display_cursor(null,null,'ALLSTATS'));

alter session set max_dump_file_size = unlimited;
ALTER SESSION SET tracefile_identifier = 'vpdexample';

ALTER SESSION SET EVENTS '10053 trace name context forever, level 1';

select /* comment to force parse */ count(*) from test.table_list;

ALTER SESSION SET EVENTS '10053 trace name context OFF';

spool off

